#version 330 core
#auto_defines

uniform sampler2D   Frame;
uniform vec4        LeftMask;
uniform vec4        RightMask;

#ifdef _VERTEX_

layout(location = 0) in  vec4  VertexPos;
layout(location = 1) in  vec4  VertexTexCoord;

out vec2  TexCoord;

void main()
{
    gl_Position = VertexPos;
    TexCoord = VertexTexCoord.xy;
}

#else

in  vec2  TexCoord;

layout(location = 0) out vec4  OutColor;

void main()
{
    vec2 TexCoordRight = TexCoord * vec2(1.0, 0.5);
    vec2 TexCoordLeft  = TexCoordRight + vec2(0.0, 0.5);
	OutColor = texture(Frame, TexCoordLeft) * LeftMask + texture(Frame, TexCoordRight) * RightMask;
}

#endif
