#version 330 core
#auto_defines

uniform sampler2D   Frame;
uniform float       Param; // (WinSizeX)

#ifdef _VERTEX_

layout(location = 0) in  vec4  VertexPos;
layout(location = 1) in  vec4  VertexTexCoord;

out vec2  TexCoord;

void main()
{
    gl_Position = VertexPos;
    TexCoord = VertexTexCoord.xy;
}

#else

in  vec2  TexCoord;

layout(location = 0) out vec4  OutColor;

void main()
{
    vec2 texCoord = TexCoord;

#ifdef HOR_INTERLACE
	texCoord.x *= 0.5;
    if ((int(TexCoord.x * Param) & 1) == 1)
	    texCoord.x += 0.5;
#else
	texCoord.y *= 0.5;
    if ((int(TexCoord.y * Param) & 1) == 1)
	    texCoord.y += 0.5;
#endif

	OutColor = textureLod(Frame, texCoord, 0);
}

#endif
