#version 330 core
#auto_defines

uniform sampler2D   guiTexture;
uniform mat4x4      Mvp;
uniform float       AntiExposure;

#ifdef _VERTEX_

layout(location = 0) in  vec4  Position;
layout(location = 1) in  vec2  TexCoord;

out vec2  fTexCoord;

void    main()
{
    //vec3 pos = normalize(vec3(Position.xy, 1.0));
    //pos.z = -pos.z;
    //pos.xy *= -1.0;
    //gl_Position = Mvp * vec4(pos, 1.0);
    gl_Position = Mvp * Position;
    fTexCoord = TexCoord;
}

#else

in vec2  fTexCoord;

layout(location = 0) out vec4  OutColor;

void    main()
{
    OutColor = texture(guiTexture, fTexCoord);
    OutColor.rgb = log2(max(1.0 - OutColor.rgb, 1.0e-9)) * AntiExposure;
}

#endif
