#version 330 core
#auto_defines

uniform sampler2D   Frame;
uniform vec4        Param;

#ifdef _VERTEX_

layout(location = 0) in  vec4  VertexPos;
layout(location = 1) in  vec4  VertexTexCoord;

out vec2  TexCoord;

void main()
{
    gl_Position = VertexPos;
    TexCoord = VertexTexCoord.xy * Param.xy + Param.zw;
}

#else

in  vec2  TexCoord;

layout(location = 0) out vec4  OutColor;

void main()
{
	OutColor = texture(Frame, TexCoord);
}

#endif
