#version 330 core
#auto_defines

uniform sampler2D  Tex;
uniform vec2       Offset;

#ifdef _VERTEX_

layout(location = 0) in  vec4  VertexPos;
layout(location = 1) in  vec4  VertexTexCoord;

out vec2  TexCoord;

void main()
{
    gl_Position = VertexPos;
    TexCoord = VertexTexCoord.xy;
}

#else

in  vec2  TexCoord;

layout(location = 0) out vec4  OutColor;

void main()
{
	OutColor = texture(Tex, TexCoord + Offset);
}

#endif
