#version 330 core
#auto_defines

uniform sampler2D    Base;
uniform vec2         Param; // (Bright, Exposure)

#ifdef _VERTEX_

layout(location = 0) in  vec4  VertexPos;
layout(location = 1) in  vec4  VertexTexCoord;

out vec2  TexCoord;

void main()
{
    gl_Position = VertexPos;
    TexCoord = VertexTexCoord.xy;
}

#else

in  vec2  TexCoord;

layout(location = 0) out vec4  OutColor;

void main()
{
    OutColor = texture(Base, TexCoord) * Param.x;
    OutColor.rgb = 1.0 - exp(-Param.y * OutColor.rgb);
}

#endif
