#version 330 core
#auto_defines

uniform sampler2D    Base;
uniform vec2         Param; // (Alpha, Exposure)

#ifdef _VERTEX_

layout(location = 0) in  vec4  VertexPos;
layout(location = 1) in  vec4  VertexTexCoord;

out vec2  TexCoord;

void main()
{
    gl_Position = VertexPos;
    TexCoord.x = VertexTexCoord.x;
	TexCoord.y = 1.0f - VertexTexCoord.y;
}

#else

in  vec2  TexCoord;

layout(location = 0) out vec4  OutColor;

void main()
{
    OutColor.rgb = texture(Base, TexCoord).rgb * Param.x;
    OutColor.rgb = 1.0 - exp(-Param.y * OutColor.rgb);
    OutColor.a = Param.x;
	//OutColor.r = 0.5;
}

#endif
