#version 330 compatibility
#auto_defines

uniform mat4x4 ModelViewProj;
uniform vec3   EyeDir;
uniform vec4   Color;

#ifdef _VERTEX_

//attribute float gl_Vertex;
//attribute float gl_MultiTexCoord0;

out vec3 vNormal;

void main()
{
    gl_Position = ModelViewProj * vec4(gl_Vertex.xyz, 1.0);
    vNormal = gl_Vertex.xyz;
}

#else

in vec3 vNormal;

layout(location = 0) out vec4 FragColor;

void main()
{
    float R = dot(vNormal, EyeDir);
    FragColor.rgb = Color.rgb * clamp(1.0 - 1.15 * R, 0.0, 1.0);
    FragColor.a = Color.a;
}

#endif
