#version 330 compatibility
precision highp float;

//attribute  vec3  gl_Vertex;           // Sprite center world position
//attribute  vec4  gl_Color;            // Sprite color, Sprite vertex Id
//attribute  vec2  gl_MultiTexCoord0;   // 1/Radius, Luminosity

uniform mat4x4  mvp;    // mvp matrix
uniform vec2    Param;  // Size, Alpha

#ifdef _VERTEX_

out vec4  Color;

void main()
{
    gl_Position  = mvp * gl_Vertex;
    gl_PointSize = Param.x;
    Color = vec4(gl_Color.rgb, Param.y);
}

#else

in vec4  Color;

void main()
{
    gl_FragColor = Color;
}


#endif
