#version 330 core
#auto_defines

uniform sampler2D   Texture;
uniform mat4x4      Mvp;
uniform vec4        Color;
uniform vec4        TexCoordTransf;

#ifdef _VERTEX_

layout(location = 0) in  vec4  VertexPos;
layout(location = 1) in  vec4  VertexTexCoord;

out vec2  TexCoord;

void main()
{
    gl_Position = Mvp * VertexPos;
    TexCoord = VertexTexCoord.xy;
}

#else

in  vec2  TexCoord;

layout(location = 0) out vec4  OutColor;

void main()
{
    OutColor = texture(Texture, TexCoord * TexCoordTransf.zw + TexCoordTransf.xy) * max(Color, 0.0);
}

#endif
