#version 330 core
#auto_defines

uniform vec3    uPosition;
uniform vec4    uColor;
uniform mat4x4  ModelViewProjMatrix;    // mvp matrix

#ifdef _VERTEX_

layout(location = 0) in  vec3   vPosition;
layout(location = 1) in  vec2   vLumRad;
layout(location = 2) in  vec4   vColor;

void main()
{
    gl_Position = ModelViewProjMatrix * vec4(uPosition, 1.0);
    gl_PointSize = 2.0;
}

#else

layout(location = 0) out vec4  OutColor;

void main()
{
    OutColor = uColor;
}

#endif
