#include "tg_common.glsl"

#ifdef _FRAGMENT_

//-----------------------------------------------------------------------------

float   HeightMapAsteroid(vec3 point)
{
    // Global landscape
    noiseOctaves = 2.0;
    vec3  p = point * mainFreq + Randomize;
    float height = (Fbm(p) + 0.7) * 0.7;

    noiseOctaves = 8; // Height distortion
    float distort = 0.01 * Fbm(point * montesFreq + Randomize);
    height += distort;

    // Hills
    noiseOctaves = 5;
    float hills = (0.5 + 1.5 * Fbm(p * 0.0721)) * hillsFreq;
    hills = Fbm(p * hills) * 0.15;
    noiseOctaves = 2;
    float hillsMod = smoothstep(0, 1, Fbm(p * hillsFraction) * 3.0);
    height *= 1.0 + hillsMagn * hills * hillsMod;

    // Craters
    noiseOctaves = 3;   // Craters roundness distortion
    craterDistortion = 1.0;
    craterRoundDist  = 0.03;
    heightFloor = -0.1;
    heightPeak  = 0.6;
    heightRim   = 1.0;
    float crater = CraterNoise(point, craterMagn, craterFreq, craterSqrtDensity, craterOctaves);
    //noiseOctaves = 9.0;
    //noiseH       = 1.0;
    //noiseOffset  = 1.0;
    //crater = 0.5 * RidgedMultifractalDetail(point * montesFreq + Randomize, 2.0, 0.25 * crater);
/*
    noiseOctaves = 8; // Height distortion
    craterDistortion = montesMagn * Fbm(point * montesFreq * 0.3 + Randomize);
    //height += craterDistortion;

    // Get crater landscape
    craterDistortion += 1.0;
    craterRoundDist = 0.03;
    noiseOctaves = 3;  // Craters roundness distortion
    heightFloor  = -0.3;
    heightPeak   = -0.25;
    heightRim    = 0.1;
    float crater = CraterNoise(point, craterMagn, craterFreq*2, craterSqrtDensity*2, craterOctaves);
*/ 
    return height + crater;
}

//-----------------------------------------------------------------------------

void main()
{
    float height = HeightMapAsteroid(GetSurfacePoint());
    OutColor = vec4(height);
}

//-----------------------------------------------------------------------------

#endif
