#include "tg_common.glsl"

#ifdef _FRAGMENT_

//-----------------------------------------------------------------------------

float   GlowMapSun(vec3 point)
{
    // Flows
    noiseOctaves = 5;
    vec3  p = point * colorDistFreq + Randomize;
    vec3  dist = 2.5 * Fbm3D(p * 0.5);
    noiseOctaves = 3;
    float flows = Fbm(p * 7.5 + dist);

    // Granularity
    noiseOctaves = 5;
    p = point * hillsFreq + Randomize;
    dist = venusFreq * Fbm3D(p * 0.2);
    vec2  cell = Cell3Noise2(p + dist);
    float gran = smoothstep(0.1, 1.0, sqrt(abs(cell.y - cell.x)));

    // Solar spots
	float botMask = 1.0;
	float filMask = 0.0;
	float filaments = 0.0;
	if (mareSqrtDensity > 0.01)
	{
        noiseOctaves = 5;
        SolarSpotsTempNoise(point, botMask, filMask, filaments);
	}

	float granTopTemp = mix(1.0, 0.5, cloudsStyle);
	float granBotTemp = mix(0.5, 0.8, cloudsStyle);
	const float surfTemp = 1.0;
	const float filTemp  = 1.0;
	const float spotTemp = 0.5;

	float  global = (flows * 0.1 + mix(granBotTemp, granTopTemp, gran) * (1.0 - filMask)) * mix(spotTemp, surfTemp, botMask) + filMask * mix(spotTemp, filTemp, filaments);
    return global;
}

//-----------------------------------------------------------------------------

void main()
{
    vec3  point = GetSurfacePoint();
    float surfTemp = GlowMapSun(point);
	surfTemp *= surfTemperature; // in thousand Kelvins
    //surfTemp = (mix(surfTemp, 1.0-surfTemp, cloudsStyle) * 0.5 + 0.5) * 0.7 * surfTemperature; // in thousand Kelvins

	//float r = log(surfTemp) * 0.188 + 0.1316;
	//OutColor = vec4(r, 0.0, 0.0, 1.0);

	OutColor.rgb = UnitToColor24(log(surfTemp) * 0.188 + 0.1316);
	OutColor.a = 1.0;

	//OutColor.rgb = UnitToColor24(surfTemp * 0.1);
	//OutColor.a = 1.0;
}

//-----------------------------------------------------------------------------

#endif
